package Intel;
import Temp.Label;
import Temp.Temp;

public class IntelFrame extends Frame.Frame {
    private int parCount;
    private int localCount;
    private Temp FP;
    private Temp RV;

    public IntelFrame() {
	this(new Label());
    }

    public IntelFrame(Label n) {
	name = n;
	localCount = 0;
	parCount = 0;
	FP = new Temp();
	RV = new Temp();
    }

    public Frame.Frame newFrame(Label n,Util.BoolList e) {
	Intel.IntelFrame result = new IntelFrame(n);

	Frame.AccessList f = result.formals = null;
	Frame.Access a;

	for (; e!=null; e = e.tail) {
	    if (e.head) {
		a = new InFrame(result.parCount);
		result.parCount += 4;
	    }
	    else
		a = new InReg();

	    if (result.formals == null)
		result.formals = f = new IntelAccessList(a,null);
	    else {
		f.tail = new IntelAccessList(a,null);
		f = f.tail;
	    }
	}

	return result;
    }

    public Frame.Access allocLocal(boolean escape) {
	if (escape) {
	    localCount -= 4;
	    return new InFrame(localCount);
	}
	else
	    return new InReg();
    }

    public Temp FP() { return FP; }

    public Temp RV() { return RV; }

    public String string(Label label, String value) {
	return label + ": .ascii \"" + value + "\"\n";
    }

    public Tree.Stm procEntryExit1(Tree.Stm body) {
	return body;
    }

    public Tree.Stm procEntryExit1(Tree.Exp body) {
	return procEntryExit1(new Tree.MOVE(new Tree.TEMP(RV),body));
    }

    public int wordSize() { return 4; }
}
