package Parse;

public class Parse {
  public ErrorMsg.ErrorMsg errorMsg;
  public Absyn.Exp absyn;

  public Parse(String filename) {
      errorMsg = new ErrorMsg.ErrorMsg(filename);
      java_cup.runtime.Symbol symbol;
      java.io.InputStream inp;

      try { inp = new java.io.FileInputStream(filename); }
      catch (java.io.FileNotFoundException e) {
	  System.out.println("File not found: " + filename);
	  return;
      }

      Grm parser = new Grm(new Yylex(inp,errorMsg), errorMsg);

      try {
	  symbol = parser.parse();
	  inp.close();
      }
      catch (Throwable e) { return; }

      absyn = (Absyn.Exp)(symbol.value);
      System.out.println("Fine dell'analisi sintattica");

      if (absyn != null) {
	  // (new Absyn.Print(System.out)).prExp(absyn,0);
          Semant.Semant s = new Semant.Semant(errorMsg);
          s.transProg(absyn);
          System.out.println("Fine dell'analisi semantica");
      }
      else System.out.println("Attributo semantico pari a null");
  }
}
