package Semant;

class Env {
    public Symbol.Table venv; // value environment
    public Symbol.Table tenv; // type environment
    public ErrorMsg.ErrorMsg errorMsg;

    public Env(ErrorMsg.ErrorMsg err){
	Symbol.Symbol s;

	errorMsg = err;

	venv = new Symbol.Table();
	tenv = new Symbol.Table();

	tenv.put(sym("int"),Semant.INT);
	tenv.put(sym("string"),Semant.STRING);

	// Loading all predefined functions
	s = sym("print");
	venv.put(s,
		 new FunEntry(s,new Types.RECORD(sym("s"),Semant.STRING,null),
		 Semant.VOID));

	s = sym("flush");
	venv.put(s,new FunEntry(s,null,Semant.VOID));

	s = sym("getchar");
	venv.put(s,new FunEntry(s,null,Semant.STRING));

	s = sym("ord");
	venv.put(s,
		 new FunEntry(s,new Types.RECORD(sym("s"),Semant.STRING,null),
		 Semant.INT));

	s = sym("chr");
	venv.put(s,
		 new FunEntry(s,new Types.RECORD(sym("i"),Semant.INT,null),
		 Semant.STRING));

	s = sym("size");
	venv.put(s,
		 new FunEntry(s,new Types.RECORD(sym("s"),Semant.STRING,null),
		 Semant.INT));

	s = sym("substring");
	venv.put(s,
		 new FunEntry(s,new Types.RECORD(sym("s"),Semant.STRING,
				new Types.RECORD(sym("first"),Semant.INT,
			        new Types.RECORD(sym("n"),Semant.INT,null))),
		 Semant.STRING));

	s = sym("concat");
	venv.put(s,
		 new FunEntry(s,new Types.RECORD(sym("s1"),Semant.STRING,
			        new Types.RECORD(sym("s2"),Semant.STRING,
					       null)),
                 Semant.STRING));

	s = sym("not");
	venv.put(s,
		 new FunEntry(s,new Types.RECORD(sym("i"),Semant.INT,null),
		 Semant.INT));

        s = sym("exit");
	venv.put(s,
		 new FunEntry(s,new Types.RECORD(sym("i"),Semant.INT,null),
		 Semant.VOID));
    }

    private Symbol.Symbol sym(String name) {
	return Symbol.Symbol.symbol(name);
    }
}
